'use strict';

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var test = require('tape');

var _require = require('../itertools.js');

var range = _require.range;
var enumerate = _require.enumerate;

test('test range()', function (t) {
  var expected = [];
  var index = 0;
  t.plan(7);
  for (var i = 0; i < 7; i++) {
    expected.push(i);
  }
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)(range()), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var actual = _step.value;

      if (index === expected.length) break;
      t.equal(actual, expected[index++]);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
});

test('test range(3)', function (t) {
  var expected = [];
  var index = 0;
  t.plan(7);
  for (var i = 3; i < 10; i++) {
    expected.push(i);
  }
  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = (0, _getIterator3.default)(range(3)), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var actual = _step2.value;

      if (index === expected.length) break;
      t.equal(actual, expected[index++]);
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }
});

test('test range(3, 10)', function (t) {
  var expected = [];
  var index = 0;
  t.plan(7);
  for (var i = 3; i < 10; i++) {
    expected.push(i);
  }
  var _iteratorNormalCompletion3 = true;
  var _didIteratorError3 = false;
  var _iteratorError3 = undefined;

  try {
    for (var _iterator3 = (0, _getIterator3.default)(range(3, 10)), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
      var actual = _step3.value;

      t.equal(actual, expected[index++]);
    }
  } catch (err) {
    _didIteratorError3 = true;
    _iteratorError3 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion3 && _iterator3.return) {
        _iterator3.return();
      }
    } finally {
      if (_didIteratorError3) {
        throw _iteratorError3;
      }
    }
  }
});

test('test range(3, 10, 2)', function (t) {
  var expected = [];
  var index = 0;
  t.plan(4);
  for (var i = 3; i < 10; i += 2) {
    expected.push(i);
  }
  var _iteratorNormalCompletion4 = true;
  var _didIteratorError4 = false;
  var _iteratorError4 = undefined;

  try {
    for (var _iterator4 = (0, _getIterator3.default)(range(3, 10, 2)), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
      var actual = _step4.value;

      t.equal(actual, expected[index++]);
    }
  } catch (err) {
    _didIteratorError4 = true;
    _iteratorError4 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion4 && _iterator4.return) {
        _iterator4.return();
      }
    } finally {
      if (_didIteratorError4) {
        throw _iteratorError4;
      }
    }
  }
});

test('test range(3, undefined, -2)', function (t) {
  var expected = [];
  var index = 0;
  t.plan(4);
  for (var i = 3; i > -4; i -= 2) {
    expected.push(i);
  }
  var _iteratorNormalCompletion5 = true;
  var _didIteratorError5 = false;
  var _iteratorError5 = undefined;

  try {
    for (var _iterator5 = (0, _getIterator3.default)(range(3, undefined, -2)), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
      var actual = _step5.value;

      if (index === expected.length) break;
      t.equal(actual, expected[index++]);
    }
  } catch (err) {
    _didIteratorError5 = true;
    _iteratorError5 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion5 && _iterator5.return) {
        _iterator5.return();
      }
    } finally {
      if (_didIteratorError5) {
        throw _iteratorError5;
      }
    }
  }
});

test('test range(3, 10, -2)', function (t) {
  t.plan(1);
  t.deepEqual(range(3, 10, -2).toArray(), []);
});

test('test range(-3)', function (t) {
  var expected = [];
  var index = 0;
  t.plan(7);
  for (var i = -3; i < 4; i++) {
    expected.push(i);
  }
  var _iteratorNormalCompletion6 = true;
  var _didIteratorError6 = false;
  var _iteratorError6 = undefined;

  try {
    for (var _iterator6 = (0, _getIterator3.default)(range(-3)), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
      var actual = _step6.value;

      if (index === expected.length) break;
      t.equal(actual, expected[index++]);
    }
  } catch (err) {
    _didIteratorError6 = true;
    _iteratorError6 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion6 && _iterator6.return) {
        _iterator6.return();
      }
    } finally {
      if (_didIteratorError6) {
        throw _iteratorError6;
      }
    }
  }
});

test('test range(1, 2, 0)', function (t) {
  var expected = [1, 1, 1, 1, 1];
  var index = 0;
  t.plan(5);
  var _iteratorNormalCompletion7 = true;
  var _didIteratorError7 = false;
  var _iteratorError7 = undefined;

  try {
    for (var _iterator7 = (0, _getIterator3.default)(range(1, 2, 0)), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
      var actual = _step7.value;

      if (index === expected.length) break;
      t.equal(actual, expected[index++]);
    }
  } catch (err) {
    _didIteratorError7 = true;
    _iteratorError7 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion7 && _iterator7.return) {
        _iterator7.return();
      }
    } finally {
      if (_didIteratorError7) {
        throw _iteratorError7;
      }
    }
  }
});

test('test enumerate()', function (t) {
  var expected = [[0, 'a'], [1, 'b'], [2, 'c']];
  t.plan(1);
  t.deepEqual(enumerate(['a', 'b', 'c']).toArray(), expected);
});